
// crc16.c implementation file
//----------------------------
#include "crc16.h"
#include "defines.h"

static WORD crc16_table[256];

int crc16_initialize(WORD polynom)
//=================================
{
	int index;
	WORD d;
	WORD a;
	BYTE b;
	for (index=0; index<256; crc16_table[index++]=a)
	{
		for (d=index, a=b=0; b<8; b++, d<<=1)
		{
			if (((d<<8)^a)&0x8000)
			{
				a=(a<<1)^polynom;
			}
			else
			{
				a<<=1;
			}
		}
	}
	return 0;
}

WORD crc16_onbyte(WORD crc, BYTE byte)
//======================================
{
	return ((LOBYTE(crc)<<8)^crc16_table[HIBYTE(crc)^byte]);
}

WORD crc16_onbuffer(const BYTE* buffer, DWORD length)
//=====================================================
{
	WORD crc;
	DWORD index;
	crc=START_VALUE;
	for (index=0; index<length; index++)
	{
		crc=crc16_onbyte(crc,buffer[index]);
	}
	return crc;
}
